/********************************************************************-*-c-*-*\
*               *  Class examples for Advanced Porgramming                   *
*    #####      *  (!) Giovanni Squillero <giovanni.squillero@polito.it>     *
*   ######      *                                                            *
*   ###   \     *  Copying and distribution of this file, with or without    *
*    ##G  c\    *  modification, are permitted in any medium without royalty *
*    #     _\   *  provided this notice is preserved.                        *
*    |   _/     *  This file is offered as-is, without any warranty.         *
*    |  _/      *                                                            *
*               *  See: http://staff.polito.it/giovanni.squillero/dida.php   *
\****************************************************************************/

#include <stdio.h>
#include <stdlib.h>

#include "utils.h"
#include "stack.h"
#include "castle.h"

/* local proto */
static int recSolve(void);
static __inline__ int validMove(int x, int y);

static int **Room;
static int PosX, PosY;
static int Sum;
STACK *Solution;

char *Solve(int **room)
{
	int x, y;
	STACK *s2;
	char *c;
	int n;
	
	for(x=0; x<ROOM_DIM; ++x) {
		for(y=0; y<ROOM_DIM; ++y) {
			printf(" %3d", room[x][y]);
		}
		printf("\n");
	} 
	
	Room = room;
	PosX = PosY = 0;
	Sum = Room[PosX][PosY];
	Solution = StackInit(PRIZE_SUM+1);

	if(recSolve()) {
		s2 = StackInit(PRIZE_SUM+1);
		n=0;
		while(!StackEmpty(Solution)) {
			StackPush(s2, StackPop(Solution));
			++n;
		}
		c = (char *)Malloc(n+1);
		n = 0;
		while(!StackEmpty(s2)) {
			c[n++] = StackPop(s2);
		}
		c[n] = '\0';
	
		printf("SOLUTION: %s\n", c);
	} else {
		printf("Nessuna soluzione!\n");
		c = NULL;
	}
	
	
	return c;
}

static __inline__ int validMove(int x, int y)
{
	if(x<0 || x>=ROOM_DIM)
		return 0;
	if(y<0 || y>=ROOM_DIM)
		return 0;
	return 1;
}

static int recSolve(void)
{
	static struct { int x; int y; char m; } move[4] = {
		{ +0, +1, 'E' },
		{ +0, -1, 'W' },
		{ +1, +0, 'S' },
		{ -1, +0, 'N' } };
	int p;

	if(PosX==ROOM_DIM-1 && PosY==ROOM_DIM-1 && Sum==PRIZE_SUM) {
		printf("Yeahhhhhh!!!!!!\n");
		return 1;
	}  
	if(Sum>PRIZE_SUM) {
		return 0;
	}
	
	for(p=0; p<4; ++p) {
		if(validMove(PosX+move[p].x, PosY+move[p].y)) {
			PosX += move[p].x;
			PosY += move[p].y;
			Sum += Room[PosX][PosY];
			StackPush(Solution, move[p].m);

			if(recSolve())
				return 1;

			StackPop(Solution);
			Sum -= Room[PosX][PosY];
			PosY -= move[p].y;
			PosX -= move[p].x;
		}
	}
	
	return 0;
}

