/********************************************************************-*-c-*-*\
*               *  Class examples for Advanced Porgramming                   *
*    #####      *  (!) Giovanni Squillero <giovanni.squillero@polito.it>     *
*   ######      *                                                            *
*   ###   \     *  Copying and distribution of this file, with or without    *
*    ##G  c\    *  modification, are permitted in any medium without royalty *
*    #     _\   *  provided this notice is preserved.                        *
*    |   _/     *  This file is offered as-is, without any warranty.         *
*    |  _/      *                                                            *
*               *  See: http://staff.polito.it/giovanni.squillero/dida.php   *
\****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "utils.h"

#define TILE_NUM	18

typedef struct _TILE {
	int left, right;
} TILE;

static TILE _Pool[TILE_NUM];
static int _Used[TILE_NUM];
static TILE _Snake[TILE_NUM];
static TILE _BestSnake[TILE_NUM];
static int _BestSnakeLen;

/* local protos */
static void initPool(void);
static int buildSnake(int p);

int main(int argc, char *argv[])
{
	int t;
	initPool();
	
	_BestSnakeLen = -1;
	buildSnake(-1);
	
	
	return EXIT_SUCCESS;
}


static void initPool(void)
{
	int t;
	
	for(t=0; t<TILE_NUM; ++t) {
		_Pool[t].left = rand()%2;
		_Pool[t].right = rand()%2;
		_Used[t] = 0;
	}
}
	
static int buildSnake(int p)
{
	int t;
	
	if(p+1 > _BestSnakeLen) {
		_BestSnakeLen = p+1;
		memcpy(_BestSnake, _Snake, _BestSnakeLen*sizeof (TILE));

		printf("Whoa! Found snake len %d\n", _BestSnakeLen);
		for(t=0; t<_BestSnakeLen; ++t)
			printf(" %1d-%1d", _BestSnake[t].left, _BestSnake[t].right);
		printf("\n");
		
		if(_BestSnakeLen==TILE_NUM)
			return 1;
	}

	for(t=0; t<TILE_NUM; ++t) {
		if(!_Used[t] && (p == -1 || _Snake[p].right == _Pool[t].left)) {
			_Snake[p+1] = _Pool[t];
			_Used[t] = 1;
			if(buildSnake(p+1))
				return 1;
			_Used[t] = 0;
		} else if(!_Used[t] && ( p== -1 || _Snake[p].right == _Pool[t].right)) {
			int tmp;
			tmp = _Pool[t].left;
			_Pool[t].left = _Pool[t].right;
			_Pool[t].right = tmp;
			_Snake[p+1] = _Pool[t];
			_Used[t] = 1;
			if(buildSnake(p+1))
				return 1;
			_Used[t] = 0;
		}
	}	

	return 0;
}





